/*
 * Computes the negative pdf (i.e., complementary cumulative 
 * distribution function 1-F(x)) of a convolution pdf on a 
 * "per channel" Mbps requirement basis. That is, for a given
 * rate, R, in an n-fold convolution pdf, the rate requirement 
 * for a given channel is R/n.
 */

#include <stdio.h>

main(argc, argv) 
   int argc;
   char *argv[];
{
  FILE *fd;
  FILE *fdout;
  float rate, prob;
  float totalProb;
  float baseProb;
  int count; 
  int nFold;
 
  if (argc < 4) {
     printf("Usage: negpdf [infile] [outfile] [n]\n");
     printf("n is order of n-fold convolution\n");
     exit(1);
  } 

  nFold = atoi(argv[3]); 
/*
  printf("Enter order n for this n-fold convolution : ");
  scanf("%d", &nFold);
*/
  fd = fopen(argv[1], "r"); 
  if (!fd) {
     printf("Error opening infile\n");
   }
  fdout = fopen(argv[2], "w"); 
  if (!fdout) {
     printf("Error opening outfile\n");
   }

  baseProb = 0.0;
  while (!feof(fd)) {
     fscanf(fd, "%f %f\n", &rate, &prob); 
     baseProb += prob;
  }
  fseek(fd,0,0);
  totalProb = 0.0;
  while (!feof(fd)) {
     fscanf(fd, "%f %f\n", &rate, &prob); 
     totalProb += prob;
     fprintf(fdout,"%e %e\n", rate/nFold, (baseProb - totalProb)/baseProb); 
  }
  fclose(fd);
  fclose(fdout);
}



